<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <div class="query-box">
        <div class="query-box__left">
          <el-form-item label="" prop="name">
            <el-input
              v-model="queryParams.name"
              placeholder="请输入医共体名称"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item>
            <el-button
              type="primary"
              icon="el-icon-search"
              size="mini"
              @click="handleQuery"
              >搜索</el-button
            >
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
              >重置</el-button
            >
            <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
              >新增</el-button
            >
            <el-button
              type="danger"
              plain
              icon="el-icon-delete"
              size="mini"
              :disabled="multiple"
              @click="handleDelete"
              v-hasPermi="['system:community:remove']"
              >删除</el-button
            >
          </el-form-item>
        </div>
      </div>
    </el-form>

    <!-- <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:community:remove']"
          >删除</el-button
        >
      </el-col>
    </el-row> -->

    <el-table
      v-loading="loading"
      :data="communityList"
      @selection-change="handleSelectionChange"
      border
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" align="center" label="序号" />
      <el-table-column label="医共体ID" align="center" prop="medicalCode" />
      <el-table-column label="医共体名称" align="center" prop="name" />
      <el-table-column
        label="医共体状态"
        align="center"
        prop="state"
        width="140"
      >
        <template slot-scope="scope">
          <!-- <dict-tag :options="stateOptions" :value="scope.row.state" /> -->
          {{ scope.row.state == 1 ? "启用" : "禁用" }}
        </template>
      </el-table-column>
      <el-table-column label="医共体密码" align="center" prop="pwd" />
      <el-table-column label="医共体说明" align="center" prop="remark" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="250"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="primary"
            @click="handleUpdate(scope.row)"
            style="width: 40px"
            >修改</el-button
          >
          <!-- <el-button
            size="mini"
            type="primary"
            @click="handleState(scope.row)"
            v-hasPermi="['system:community:edit']"
            style="width: 40px"
            >启用</el-button
          > -->
          <el-button
            size="mini"
            type="primary"
            @click="handleState(scope.row)"
            v-hasPermi="['system:community:edit']"
            style="width: 40px"
            >{{ scope.row.state != 1 ? "启用" : "禁用" }}</el-button
          >
          <el-button
            size="mini"
            type="primary"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:community:remove']"
            style="width: 40px"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改医共体对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="医共体ID" prop="medicalCode">
          <el-input v-model="form.medicalCode" placeholder="请输入医共体ID" />
        </el-form-item>
        <el-form-item label="医共体名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入医共体名称" />
        </el-form-item>
        <el-form-item label="医共体密码" prop="pwd">
          <el-input v-model="form.pwd" placeholder="请输入密码" />
        </el-form-item>
        <el-form-item label="医共体说明" prop="remark">
          <el-input
            v-model="form.remark"
            type="textarea"
            placeholder="请输入内容"
          />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listCommunity,
  getCommunity,
  delCommunity,
  addCommunity,
  updateCommunity,
  exportCommunity,
} from "@/api/medical/community";

export default {
  name: "Community",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 医共体表格数据
      communityList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 状态字典
      stateOptions: [],
      // 是否删除字典
      delOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        state: null,
        pwd: null,
        del: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        medicalCode: [
          { required: true, message: "医共体ID不能为空", trigger: "blur" },
        ],
        name: [
          {
            required: true,
            message: "医共体名称不能为空",
            trigger: "blur",
          },
        ],
      },
    };
  },
  created() {
    this.getList();
    this.getDicts("sys_normal_disable").then((response) => {
      this.stateOptions = response.data;
    });
    this.getDicts("del_state").then((response) => {
      this.delOptions = response.data;
    });
  },
  methods: {
    /** 查询医共体列表 */
    getList() {
      this.loading = true;
      listCommunity(this.queryParams).then((response) => {
        this.communityList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        medicalCode: null,
        name: null,
        state: null,
        pwd: null,
        remark: null,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null,
        del: null,
        stateId: "",
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      // this.$router.push({
      //   path:'/base/baseList/community-main/add'
      // })
      this.reset();
      this.open = true;
      this.title = "添加医共体";
      this.stateId = "1";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.stateId = "2";
      this.reset();
      const id = row.id || this.ids;
      getCommunity(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改医共体";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          //console.log(this.stateId);
          if (this.stateId === "2") {
            updateCommunity(this.form).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCommunity(this.form).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm("确定需要删除已选数据吗？", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delCommunity(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有医共体数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.exportLoading = true;
          return exportCommunity(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
          this.exportLoading = false;
        })
        .catch(() => {});
    },
    //启用 / 禁用
    handleState(row, num) {
      const id = row.id || this.ids;
      const parmes = {
        id,
        state: row.state == 1 ? (row.state = 2) : (row.state = 1),
      };
      updateCommunity(parmes).then(() => {
        // this.form = response.data;
        this.getList();
        this.msgSuccess('修改成功')
      });
    },
  },
};
</script>
